---
- name: ensure variables are defined
  assert:
    that:
      - lookup('varnames', item)
      - lookup('vars', item) != none
      - lookup('vars', item) | length > 0
    fail_msg: Required variable {{ item }} is not well defined
    success_msg: Required variable {{ item }} is well defined
  loop:
    - bc_portal_configuration
    - bc_portal_postgresql_password
    - bc_portal_matrix_id
    - bc_portal_matrix_password
    - bc_portal_matrix_api_key
    - bc_portal_namespace
    - bc_portal_flask_secret

- name: Ensure portal directory
  file:
    path: /var/lib/portal-docker-compose
    owner: root
    group: root
    state: directory

- name: create bc configuration file
  template:
    src: bc_configuration.yml.j2
    dest: /var/lib/portal-docker-compose/bc_configuration.yaml
    owner: root
    group: root
    mode: 0660
  vars:
    bc_portal_configuration_base:
      GLOBAL_NAMESPACE: "{{ bc_portal_namespace }}"
      SQLALCHEMY_DATABASE_URI: "postgresql://{{ bc_portal_postgresql_user }}:{{ bc_portal_postgresql_password }}@db:5432/{{ bc_portal_postgresql_database }}"
      SQLALCHEMY_TRACK_MODIFICATIONS: true
      SECRET_KEY: "{{ bc_portal_flask_secret }}"
      SSH_PRIVATE_KEY_PATH: "/ssh/.ssh/id_rsa"
      SSH_PUBLIC_KEY_PATH: "/ssh/.ssh/id_rsa.pub"
      TERRAFORM_DIRECTORY: /terraform
    bc_portal_configuration_merged: "{{ bc_portal_configuration_base | combine(bc_portal_configuration) }}"

- name: Update compose definitions
  template:
    src: docker-compose.yml.j2
    dest: /var/lib/portal-docker-compose/docker-compose.yml
    owner: root
    group: root
    mode: 0660

- name: Pull all images
  command: docker-compose pull --quiet
  args:
    chdir: /var/lib/portal-docker-compose


- name: Start all containers
  command: docker-compose up -d
  args:
    chdir: /var/lib/portal-docker-compose
